INTRODUCTION
============

This tool is part of the xcms/camera/XSeeker workflow, and it inserts
between camera and XSeeker. It takes in input a rdata producd by camera,
gather some data from mzxml original files, and create a database
containing all these informations organized in such a way that XSeeker
has just to display the data without manipulating them anymore, which
makes it a lot faster and easier to use.


PREREQUISITES
=============
There is not real preriquesite to understand how this tool works
and to modify it. There is a single R script - XSeekerPreparator.R - that do
all the work.

You can make this tool work alone, but you can integrate it with galaxy.
In this case, you need to have a galaxy instance you can configure.
It is also recomended to have access to the datatypes definitions (in
the python files) to make the outputs recognized by galaxy as XSeeker's
database files.


DESIGN
======
This tool is very simple and does a little number of things, so there is
only a single file: XSeekerPreparator.R .
There is a test/test.sh file that can be used as an example to know how
to use this tool.

You will find the galaxy patches in the galaxy/ directory. These files
are not meant to be copy/paste-ed. The content of these files must be
added to the existing files of your galaxy instance


REQUIREMENT
=====

 - optparse
 - xcms
 - blob
 - fst
 - DBModelR
 - stringr
 - optparse
 - galaxy (optional)

#### R 4.0.0
 - `export R_MAJOR=4 R_VERSION=4.0.0 BUILD_TARGET_DIR=~/R/`
 - `wget https://cran.rstudio.com/src/base/R-${R_MAJOR}/R-${R_VERSION}.tar.gz`
 - `tar -xf "R-${R_VERSION}.tar.gz"`
 - `cd ./R-${R_VERSION}/`
 - `./configure --prefix="${BUILD_TARGET_DIR}" --with-readline="no" --with-x="no"`
 - `export CC="gcc -fPIC"`
 - `make`
 - `make install`

#### Packages
```bash
~/R/bin/R -e "
install.packages(
    c(
        'optparse',
        'blob',
        'fst',
        'stringr',
        'optparse',
        'RSQLite',
        'remotes',
        'BiocManager'
    ), repos='https://cloud.r-project.org'
)" && \
~/R/bin/R -e '
    remotes::install_github("LainPavot/DBModelR", force=TRUE)
' && \
~/R/bin/R -e '
    BiocManager::install("xcms")
'
```

#### galaxy
```bash
git clone https://github.com/galaxyproject/galaxy
```

DEPLOY
=====

Install the tool in galaxy:  
Open each file in the galaxy/ directory and copy their content to their
respective files in your galaxy instance.  
Copy XSeekerPreparator.R in galaxy/tool/tools/LC-MSMS/

METADATA
--------

 - **@name**: XSeekerPreparator
 - **@version**: 1.3.0
 - **@authors**: Lain Pavot
 - **@date creation**: 15/09/2020

NOTES
-----
Developed and tested using:

 - optparse 1.6.6
 - xcms 3.10.2
 - blob 1.2.1
 - fst 0.9.4
 - DBModelR
 - stringr 1.4.0
 - galaxy 21.01